
#include <Windows.h>
#include <mmreg.h>

#pragma comment (linker, "/ENTRY:main")
#pragma comment (lib, "Winmm.lib")

static PBYTE m_pbBuffer = NULL;
static SIZE_T m_szBuffer = 0;

LRESULT WINAPI MMIOProc(MMIOINFO* lpmmioinfo, UINT uMsg, LONG lParam1, LONG lParam2) {
	
	switch (uMsg) {
		case MMIOM_OPEN:
		case MMIOM_CLOSE:

			lpmmioinfo->lDiskOffset = 0;
			return 0;

		case MMIOM_READ:

			SIZE_T szRead;

			if (lpmmioinfo->lDiskOffset + lParam2 > m_szBuffer)
				szRead = m_szBuffer - lpmmioinfo->lDiskOffset;
			else
				szRead = lParam2;

			memcpy((PVOID)lParam1, m_pbBuffer + lpmmioinfo->lDiskOffset, szRead);

			lpmmioinfo->lDiskOffset += szRead;

			return szRead;

		case MMIOM_SEEK:

			switch (lParam2) {
				case SEEK_SET:
					lpmmioinfo->lDiskOffset = lParam1;
					break;
				case SEEK_CUR:
					lpmmioinfo->lDiskOffset += lParam1;
					break;
				case SEEK_END:
					lpmmioinfo->lDiskOffset = m_szBuffer - lParam1 - 1;
			}

			if (lpmmioinfo->lDiskOffset < 0)
				lpmmioinfo->lDiskOffset = 0;
			else if (lpmmioinfo->lDiskOffset > m_szBuffer)
				lpmmioinfo->lDiskOffset = m_szBuffer;

			return lpmmioinfo->lDiskOffset;
	}

	return -1;

}


void main() {

	// Load from resource MPEGLAYER3WAVEFORMAT wave
	HRSRC hRes = FindResource(NULL, MAKEINTRESOURCE(101), RT_RCDATA);
	if (!hRes)
		ExitProcess(HRESULT_FROM_WIN32(GetLastError()));

	HGLOBAL hMem = LoadResource(NULL, hRes);
	if (!hMem)
		ExitProcess(HRESULT_FROM_WIN32(GetLastError()));

	m_pbBuffer = (PBYTE)LockResource(hMem);
	if (!m_pbBuffer)
		ExitProcess(HRESULT_FROM_WIN32(GetLastError()));

	m_szBuffer = SizeofResource(NULL, hRes);
	if (!m_szBuffer)
		ExitProcess(HRESULT_FROM_WIN32(GetLastError()));

	// Install IO proc
	if (NULL == mmioInstallIOProc(' ZYX', (LPMMIOPROC)MMIOProc, MMIO_INSTALLPROC))
		ExitProcess(E_FAIL);

	// Open in-memory file
	MCIERROR merr = mciSendString(L"open x.XYZ+ type waveaudio alias music", NULL, 0, NULL);
	if (merr)
		ExitProcess(merr);

	// Play
	merr = mciSendString(L"play music wait", NULL, 0, NULL);

	ExitProcess(merr);

}
